use std::cmp::Ordering;

use ::task_state::TaskState;


///
pub struct Task
{
   ///
   pub name: String,

   ///
   pub state: TaskState
}



impl Task
{
   ///
   pub fn new(task_name: &str) -> Task
   {
      Task
      {
         name: String::from(task_name),
         state: TaskState::Starting
      }
   }

   ///
   pub fn set_processing_func(&self) -> i8
   {
      0
   }

   ///
   pub fn process(&mut self)
   {
      self.state = TaskState::Processing;
      println!("Processing task.");
      self.state = TaskState::Finished;
   }
}

impl PartialEq for Task
{
   fn eq(&self, other: &Self) -> bool
   {
       self.name.eq(&other.name)
   }
}

impl Eq for Task
{
}

impl PartialOrd for Task
{
   fn partial_cmp(&self, other: &Self) -> Option<Ordering>
   {
      Some(self.cmp(other))
   }
}

impl Ord for Task
{
   fn cmp(&self, other: &Self) -> Ordering
   {
      self.name.cmp(&other.name)
   }
}
